package ru.uc_itcom.esd.view.trailer;

import com.vaadin.flow.component.UI;
import com.vaadin.flow.router.Route;
import io.jmix.core.EntityStates;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.model.CollectionLoader;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;
import ru.uc_itcom.esd.entity.Participant;
import ru.uc_itcom.esd.entity.ParticipantTrailer;
import ru.uc_itcom.esd.utils.ViewHelper;
import ru.uc_itcom.esd.view.main.MainView;
import ru.uc_itcom.esd.view.vehicle.ParticipantVehicleDetailView;

import java.util.Objects;
import java.util.Optional;

@Route(value = "participantTrailers", layout = MainView.class)
@ViewController("ParticipantTrailer.list")
@ViewDescriptor("participant-trailer-list-view.xml")
@LookupComponent("participantTrailersDataGrid")
@DialogMode(width = "64em")
public class ParticipantTrailerListView extends StandardListView<ParticipantTrailer> {

    private Participant participant;

    @Autowired
    private EntityStates entityStates;

    @ViewComponent
    private CollectionLoader<ParticipantTrailer> participantTrailersDl;

    @ViewComponent
    private JmixButton createBtn;

    @Subscribe
    public void onReady(final ReadyEvent event) {
        Optional.ofNullable(ViewHelper.findComponentByClass(Objects.requireNonNull(UI.getCurrent().getElement().getComponent().orElse(null)), ParticipantVehicleDetailView.class))
                .map(ParticipantVehicleDetailView.class::cast)
                .map(StandardDetailView::getEditedEntity)
                .ifPresentOrElse(
                        vehicle -> {
                            if (entityStates.isNew(vehicle)) {
                                createBtn.setEnabled(false);
                            }
                            participantTrailersDl.setParameter("participant", vehicle.getParticipant());
                            participantTrailersDl.setParameter("trailers", vehicle.getTrailers());
                        },
                        () -> participantTrailersDl.setParameter("participant", participant)
                );

        participantTrailersDl.load();
    }

    public void setParticipant(Participant participant) {
        this.participant = participant;
    }
}